#if defined(__linux__)
#if defined(__mn10300__)

/*
 * Use Linux system call.
 */

#define SYS_exit          1
#define SYS_fork          2
#define SYS_wait4       114
#define SYS_kill         37
#define SYS_execve       11

#define SYS_read          3
#define SYS_write         4
#define SYS_open          5
#define SYS_close         6

#define SYS_dup          41
#define SYS_pipe         42
#define SYS_dup2         63
#define SYS_pipe2       332

#define SYS_sigaction    67 /* rt_sigaction is 174 */
#define SYS_sigprocmask 126 /* rt_sigprocmask is 175 */

#define SYS_getpid       20
#define SYS_getppid      64
#define SYS_getsid      147
#define SYS_setsid       66
#define SYS_getpgid     132
#define SYS_setpgid      57
#define SYS_getpgrp      65

#define SYS_chdir        12
#define SYS_ioctl        54
#define SYS_brk          45
#define SYS_getdents    141
#define SYS_getcwd      183

	.section .text

	.globl	____exit
	.type	____exit, @function
____exit:
	mov	SYS_exit, d0
	syscall
	mov	d1, d0
	rets

	.globl	___fork
	.type	___fork, @function
___fork:
	mov	SYS_fork, d0
	syscall
	mov	d1, d0
	rets

	.globl	___wait4
	.type	___wait4, @function
___wait4:
	mov	SYS_wait4, d0
	syscall
	mov	d1, d0
	rets

	.globl	___kill
	.type	___kill, @function
___kill:
	mov	SYS_kill, d0
	syscall
	mov	d1, d0
	rets

	.globl	___execve
	.type	___execve, @function
___execve:
	mov	SYS_execve, d0
	syscall
	mov	d1, d0
	rets

	.globl	___read
	.type	___read, @function
___read:
	mov	SYS_read, d0
	syscall
	mov	d1, d0
	rets

	.globl	___write
	.type	___write, @function
___write:
	mov	SYS_write, d0
	syscall
	mov	d1, d0
	rets

	.globl	___open
	.type	___open, @function
___open:
	mov	SYS_open, d0
	syscall
	mov	d1, d0
	rets

	.globl	___close
	.type	___close, @function
___close:
	mov	SYS_close, d0
	syscall
	mov	d1, d0
	rets

	.globl	___dup
	.type	___dup, @function
___dup:
	mov	SYS_dup, d0
	syscall
	mov	d1, d0
	rets

	.globl	___pipe
	.type	___pipe, @function
___pipe:
	mov	SYS_pipe, d0
	syscall
	mov	d1, d0
	rets

	.globl	___dup2
	.type	___dup2, @function
___dup2:
	mov	SYS_dup2, d0
	syscall
	mov	d1, d0
	rets

	.globl	___pipe2
	.type	___pipe2, @function
___pipe2:
	mov	SYS_pipe2, d0
	syscall
	mov	d1, d0
	rets

	.globl	___sigaction
	.type	___sigaction, @function
___sigaction:
	mov	SYS_sigaction, d0
	syscall
	mov	d1, d0
	rets

	.globl	___sigprocmask
	.type	___sigprocmask, @function
___sigprocmask:
	mov	SYS_sigprocmask, d0
	syscall
	mov	d1, d0
	rets

	.globl	___getpid
	.type	___getpid, @function
___getpid:
	mov	SYS_getpid, d0
	syscall
	mov	d1, d0
	rets

	.globl	___getppid
	.type	___getppid, @function
___getppid:
	mov	SYS_getppid, d0
	syscall
	mov	d1, d0
	rets

	.globl	___getsid
	.type	___getsid, @function
___getsid:
	mov	SYS_getsid, d0
	syscall
	mov	d1, d0
	rets

	.globl	___setsid
	.type	___setsid, @function
___setsid:
	mov	SYS_setsid, d0
	syscall
	mov	d1, d0
	rets

	.globl	___getpgid
	.type	___getpgid, @function
___getpgid:
	mov	SYS_getpgid, d0
	syscall
	mov	d1, d0
	rets

	.globl	___setpgid
	.type	___setpgid, @function
___setpgid:
	mov	SYS_setpgid, d0
	syscall
	mov	d1, d0
	rets

	.globl	___getpgrp
	.type	___getpgrp, @function
___getpgrp:
	mov	SYS_getpgrp, d0
	syscall
	mov	d1, d0
	rets

	.globl	___chdir
	.type	___chdir, @function
___chdir:
	mov	SYS_chdir, d0
	syscall
	mov	d1, d0
	rets

	.globl	___ioctl
	.type	___ioctl, @function
___ioctl:
	mov	SYS_ioctl, d0
	syscall
	mov	d1, d0
	rets

	.globl	___brk
	.type	___brk, @function
___brk:
	mov	SYS_brk, d0
	syscall
	mov	d1, d0
	rets

	.globl	___getdents
	.type	___getdents, @function
___getdents:
	mov	SYS_getdents, d0
	syscall
	mov	d1, d0
	rets

	.globl	_____getcwd
	.type	_____getcwd, @function
_____getcwd:
	mov	SYS_getcwd, d0
	syscall
	mov	d1, d0
	rets
#endif
#endif
